"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactFastCompare = _interopRequireDefault(require("react-fast-compare"));

var _styles = _interopRequireDefault(require("./styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ImageMapper = function ImageMapper(props) {
  var mapProp = props.map,
      srcProp = props.src,
      rerenderProps = props.rerenderProps;

  var _useState = (0, _react.useState)(JSON.parse(JSON.stringify(mapProp))),
      _useState2 = _slicedToArray(_useState, 2),
      map = _useState2[0],
      setMap = _useState2[1];

  var _useState3 = (0, _react.useState)(map),
      _useState4 = _slicedToArray(_useState3, 1),
      storedMap = _useState4[0];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isRendered = _useState6[0],
      setRendered = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      imgRef = _useState8[0],
      setImgRef = _useState8[1];

  var container = (0, _react.useRef)(null);
  var img = (0, _react.useRef)(null);
  var canvas = (0, _react.useRef)(null);
  var ctx = (0, _react.useRef)(null);
  var isInitialMount = (0, _react.useRef)(true);
  (0, _react.useEffect)(function () {
    if (isInitialMount.current) {
      isInitialMount.current = false;
    } else {
      updateCacheMap();
      initCanvas();
    }
  }, [props, isInitialMount]);
  (0, _react.useEffect)(function () {
    ctx.current = canvas.current.getContext('2d');
    updateCacheMap();
    setRendered(true);
  }, []);

  var updateCacheMap = function updateCacheMap() {
    setMap(JSON.parse(JSON.stringify(mapProp)));
  };

  var callingFn = function callingFn(shape, coords, fillColor, lineWidth, strokeColor) {
    if (shape === 'rect') {
      return drawRect(coords, fillColor, lineWidth, strokeColor);
    }

    if (shape === 'circle') {
      return drawCircle(coords, fillColor, lineWidth, strokeColor);
    }

    if (shape === 'poly') {
      return drawPoly(coords, fillColor, lineWidth, strokeColor);
    }

    return false;
  };

  var drawRect = function drawRect(coords, fillColor, lineWidth, strokeColor) {
    var _coords = _slicedToArray(coords, 4),
        left = _coords[0],
        top = _coords[1],
        right = _coords[2],
        bot = _coords[3];

    ctx.current.fillStyle = fillColor;
    ctx.current.lineWidth = lineWidth;
    ctx.current.strokeStyle = strokeColor;
    ctx.current.strokeRect(left, top, right - left, bot - top);
    ctx.current.fillRect(left, top, right - left, bot - top);
    ctx.current.fillStyle = props.fillColor;
  };

  var drawCircle = function drawCircle(coords, fillColor, lineWidth, strokeColor) {
    ctx.current.fillStyle = fillColor;
    ctx.current.beginPath();
    ctx.current.lineWidth = lineWidth;
    ctx.current.strokeStyle = strokeColor;
    ctx.current.arc(coords[0], coords[1], coords[2], 0, 2 * Math.PI);
    ctx.current.closePath();
    ctx.current.stroke();
    ctx.current.fill();
    ctx.current.fillStyle = props.fillColor;
  };

  var drawPoly = function drawPoly(coords, fillColor, lineWidth, strokeColor) {
    var newCoords = coords.reduce(function (a, v, i, s) {
      return i % 2 ? a : [].concat(_toConsumableArray(a), [s.slice(i, i + 2)]);
    }, []);
    var first = newCoords.unshift();
    ctx.current.fillStyle = fillColor;
    ctx.current.beginPath();
    ctx.current.lineWidth = lineWidth;
    ctx.current.strokeStyle = strokeColor;
    ctx.current.moveTo(first[0], first[1]);
    newCoords.forEach(function (c) {
      return ctx.current.lineTo(c[0], c[1]);
    });
    ctx.current.closePath();
    ctx.current.stroke();
    ctx.current.fill();
    ctx.current.fillStyle = props.fillColor;
  };

  var getDimensions = function getDimensions(type) {
    if (typeof props[type] === 'function') {
      return props[type](img.current);
    }

    return props[type];
  };

  var getValues = function getValues(type, measure) {
    if (type === 'width') {
      if (props.responsive) return props.parentWidth;
      if (props.natural) return img.current.naturalWidth;
      if (props.width) return measure;
      return img.current.clientWidth;
    }

    if (type === 'height') {
      if (props.responsive) return img.current.clientHeight;
      if (props.natural) return img.current.naturalHeight;
      if (props.height) return measure;
      return img.current.clientHeight;
    }

    return false;
  };

  var initCanvas = function initCanvas() {
    var firstLoad = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var imgWidth = getDimensions('width');
    var imgHeight = getDimensions('height');
    var imageWidth = getValues('width', imgWidth);
    var imageHeight = getValues('height', imgHeight);
    canvas.current.width = imageWidth;
    canvas.current.height = imageHeight;
    container.current.style.width = "".concat(imageWidth, "px");
    container.current.style.height = "".concat(imageHeight, "px");
    ctx.current = canvas.current.getContext('2d');
    ctx.current.fillStyle = props.fillColor; //ctx.strokeStyle = props.strokeColor;

    if (props.onLoad && firstLoad) {
      props.onLoad(img.current, {
        width: imageWidth,
        height: imageHeight
      });
    }

    setImgRef(img.current);
    renderPrefilledAreas();
  };

  var hoverOn = function hoverOn(area, index, event) {
    var shape = event.target.getAttribute('shape');

    if (props.active) {
      callingFn(shape, event.target.getAttribute('coords').split(','), area.fillColor, area.lineWidth || props.lineWidth, area.strokeColor || props.strokeColor);
    }

    if (props.onMouseEnter) props.onMouseEnter(area, index, event);
  };

  var hoverOff = function hoverOff(area, index, event) {
    if (props.active) {
      ctx.current.clearRect(0, 0, canvas.current.width, canvas.current.height);
      renderPrefilledAreas();
    }

    if (props.onMouseLeave) props.onMouseLeave(area, index, event);
  };

  var click = function click(area, index, event) {
    if (props.onClick) {
      event.preventDefault();

      if (props.stayHighlighted) {
        var newArea = _objectSpread({}, area);

        newArea.preFillColor = area.fillColor;
        var updatedAreas = storedMap.areas.map(function (cur) {
          return cur[props.areaKeyName] === area[props.areaKeyName] ? newArea : cur;
        });
        setMap(function (prev) {
          return _objectSpread(_objectSpread({}, prev), {}, {
            areas: updatedAreas
          });
        });
      }

      props.onClick(area, index, event);
    }
  };

  var imageClick = function imageClick(event) {
    if (props.onImageClick) {
      event.preventDefault();
      props.onImageClick(event);
    }
  };

  var mouseMove = function mouseMove(area, index, event) {
    if (props.onMouseMove) props.onMouseMove(area, index, event);
  };

  var imageMouseMove = function imageMouseMove(area, index, event) {
    if (props.onImageMouseMove) props.onImageMouseMove(area, index, event);
  };

  var scaleCoords = function scaleCoords(coords) {
    var imgWidth = props.imgWidth,
        width = props.width,
        responsive = props.responsive,
        parentWidth = props.parentWidth;
    var scale = width && imgWidth && imgWidth > 0 ? width / imgWidth : 1;

    if (responsive && parentWidth) {
      return coords.map(function (coord) {
        return coord * scale / (imgRef.naturalWidth / parentWidth);
      });
    }

    return coords.map(function (coord) {
      return coord * scale;
    });
  };

  var renderPrefilledAreas = function renderPrefilledAreas() {
    map.areas.map(function (area) {
      if (!area.preFillColor) return false;
      callingFn(area.shape, scaleCoords(area.coords), area.preFillColor, area.lineWidth || props.lineWidth, area.strokeColor || props.strokeColor);
      return true;
    });
  };

  var computeCenter = function computeCenter(area) {
    if (!area) return [0, 0];
    var scaledCoords = scaleCoords(area.coords);

    switch (area.shape) {
      case 'circle':
        return [scaledCoords[0], scaledCoords[1]];

      case 'poly':
      case 'rect':
      default:
        {
          var n = scaledCoords.length / 2;

          var _scaledCoords$reduce = scaledCoords.reduce(function (_ref, val, idx) {
            var y = _ref.y,
                x = _ref.x;
            return !(idx % 2) ? {
              y: y,
              x: x + val / n
            } : {
              y: y + val / n,
              x: x
            };
          }, {
            y: 0,
            x: 0
          }),
              scaleY = _scaledCoords$reduce.y,
              scaleX = _scaledCoords$reduce.x;

          return [scaleX, scaleY];
        }
    }
  };

  var renderAreas = function renderAreas() {
    return map.areas.map(function (area, index) {
      var scaledCoords = scaleCoords(area.coords);
      var center = computeCenter(area);

      var extendedArea = _objectSpread(_objectSpread({}, area), {}, {
        scaledCoords: scaledCoords,
        center: center
      });

      return /*#__PURE__*/_react.default.createElement("area", {
        key: area[props.areaKeyName] || index.toString(),
        shape: area.shape,
        coords: scaledCoords.join(','),
        onMouseEnter: function onMouseEnter(event) {
          return hoverOn(extendedArea, index, event);
        },
        onMouseLeave: function onMouseLeave(event) {
          return hoverOff(extendedArea, index, event);
        },
        onMouseMove: function onMouseMove(event) {
          return mouseMove(extendedArea, index, event);
        },
        onClick: function onClick(event) {
          return click(extendedArea, index, event);
        },
        href: area.href,
        alt: "map"
      });
    });
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    id: "img-mapper",
    style: (0, _styles.default)(props).container,
    ref: container
  }, /*#__PURE__*/_react.default.createElement("img", {
    role: "presentation",
    className: "img-mapper-img",
    style: (0, _styles.default)(props).img,
    src: srcProp,
    useMap: "#".concat(map.name),
    alt: "map",
    ref: img,
    onLoad: function onLoad() {
      return initCanvas(true);
    },
    onClick: imageClick,
    onMouseMove: imageMouseMove
  }), /*#__PURE__*/_react.default.createElement("canvas", {
    className: "img-mapper-canvas",
    ref: canvas,
    style: (0, _styles.default)().canvas
  }), /*#__PURE__*/_react.default.createElement("map", {
    className: "img-mapper-map",
    name: map.name,
    style: (0, _styles.default)().map
  }, isRendered && renderAreas()));
};

ImageMapper.defaultProps = {
  active: true,
  fillColor: 'rgba(255, 255, 255, 0.5)',
  lineWidth: 1,
  map: {
    areas: [],
    name: "image-map-".concat(Math.random())
  },
  strokeColor: 'rgba(0, 0, 0, 0.5)',
  natural: false,
  height: 0,
  imgWidth: 0,
  width: 0,
  areaKeyName: 'id',
  stayHighlighted: false,
  rerenderProps: [],
  parentWidth: 0,
  responsive: false,
  onClick: null,
  onMouseMove: null,
  onImageClick: null,
  onImageMouseMove: null,
  onLoad: null,
  onMouseEnter: null,
  onMouseLeave: null
};
ImageMapper.propTypes = {
  active: _propTypes.default.bool,
  fillColor: _propTypes.default.string,
  height: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.func]),
  imgWidth: _propTypes.default.number,
  lineWidth: _propTypes.default.number,
  src: _propTypes.default.string.isRequired,
  strokeColor: _propTypes.default.string,
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.func]),
  natural: _propTypes.default.bool,
  areaKeyName: _propTypes.default.string,
  stayHighlighted: _propTypes.default.bool,
  rerenderProps: _propTypes.default.array,
  parentWidth: _propTypes.default.number,
  responsive: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  onMouseMove: _propTypes.default.func,
  onImageClick: _propTypes.default.func,
  onImageMouseMove: _propTypes.default.func,
  onLoad: _propTypes.default.func,
  onMouseEnter: _propTypes.default.func,
  onMouseLeave: _propTypes.default.func,
  map: _propTypes.default.shape({
    areas: _propTypes.default.arrayOf(_propTypes.default.shape({
      area: _propTypes.default.shape({
        coords: _propTypes.default.arrayOf(_propTypes.default.number),
        href: _propTypes.default.string,
        shape: _propTypes.default.string,
        preFillColor: _propTypes.default.string,
        fillColor: _propTypes.default.string
      })
    })),
    name: _propTypes.default.string
  })
};

var _default = /*#__PURE__*/_react.default.memo(ImageMapper, function (prevProps, nextProps) {
  var watchedProps = ['active', 'fillColor', 'height', 'imgWidth', 'lineWidth', 'map', 'src', 'strokeColor', 'width'].concat(_toConsumableArray(nextProps.rerenderProps));
  var propChanged = watchedProps.some(function (prop) {
    return prevProps[prop] !== nextProps[prop];
  });
  return (0, _reactFastCompare.default)(prevProps.map, nextProps.map) || !propChanged;
});

exports.default = _default;